/* GCC */

#include<fstream>
#include<math.h>
#include<vector>

#define INF 1000010

int main() {
    std::ifstream in("skiing.in");
    std::ofstream out("skiing.out");

    int n;
    in >> n;
    std::vector<int> height(n + 1);
    
    height[0] = 0;
    bool t;
    for (int i = 0; i < n; i++) {
        in >> t;
        height[i+1] = height[i] + (t ? 1 : -1);
    }
    
    if (height[n] < 0) {
        for (int i = 0; i <= n; i++) {
            height[i] = -height[i];
        }
    }

    std::vector<int> min(n + 1, INF);
    std::vector<int> max(n + 1, -1);
    
    for (int i = 0; i <= n; i++) {
        if (0 <= height[i] && height[i] <= height[n]) {
            min[height[i]] = std::min(min[height[i]], i);
            max[height[i]] = std::max(max[height[i]], i);
        }
    }
    
    int res = 0;
    for (int i = 0; i <= height[n]; i++) {
        res = std::max(res, max[i] - min[i]);
    }
    
    out << res << std::endl;

    return 0;
}
